const fs = require('fs')
const ytdl  = require('ytdl-core')
var sqlite3 = require('sqlite3');
var sqlite = require('sqlite');

const { Playlist } = require('./playlist');

const db_initializer = sqlite.open({
  filename: 'database.sqlite',
  driver: sqlite3.Database,
})
db_initializer.then(db => db.run('CREATE TABLE IF NOT EXISTS playlists_manager (guild_id INT, title TEXT, playlist TEXT)'))

class PlaylistsManager {
  #playlists
  #gmanager
  #db

  constructor(gmanager) {
    // const playlists = data || PlaylistsManager.readFile(filepath)
    // this.#playlists = playlists.map(line => ({
    //   console: console.log(line),
    //   title: line.title,
    //   playlist: new Playlist({ tracks: line.playlist }),
    // }))
    this.#gmanager = gmanager
  }

  async init() {
    db_initializer.then(db => this.#db = db)
  }

  // static readFile(filename) {
  //   return JSON.parse(fs.readFileSync(filename, 'utf-8'))
  // }

  // static writeFile(filename, playlists) {
  //   return fs.writeFileSync(filename, JSON.stringify(playlists, null, 2))
  // }

  async register({ message, params }) {
    const playlist_title = params[0]
    if (playlist_title) {
      const player = this.#gmanager.get_manager(message, 'player')
      const columns = {
        guild_id: message.guild.id,
        title: playlist_title,
        playlist: JSON.stringify(player.get_playlist()),
      }
      const is_playlist_exist = await this.#db.get('SELECT guild_id, title FROM playlists_manager WHERE guild_id = guild_id AND title = title', columns)
      if (!!is_playlist_exist) {
        this.#db.run(
          'UPDATE playlists_manager SET playlist = playlist WHERE guild_id = guild_id title = title',
          columns,
        )
      } else {
        this.#db.run(
          'INSERT INTO playlists_manager (guild_id, title, playlist) VALUES (guild_id, title, playlist)',
          columns,
        )
      }
      message.channel.send(`:white_check_mark: Playlist \`${playlist_title}\` saved`)
    } else {
      message.channel.send(`:warning: Cannot save playlist without name`)
    }
  }

  async load({ message, params }) {
    const player = this.#gmanager.get_manager(message, 'player')
    // const playlist_title = params[0]
    // const named_playlist = this.#playlists.find(p => p.title === playlist_title)
    const playlist_id = params[0]
    console.log(JSON.stringify(message))
    const named_playlist = this.#playlists[playlist_id - 1]
    if (named_playlist) {
      const { title, playlist } = named_playlist
      player.set_playlist(playlist)
      message.channel.send(`:white_check_mark: Playlist \`${title}\` loaded`)
    } else {
      message.channel.send(`:warning: Cannot find playlist id \`${playlist_id}\``)
    }
  }

  async list({ message, params }) {
    message.channel.send(
      "Playlist:\n" +
        "```json\n" +
        this.#playlists.map((p, idx) => `${idx+1}: ${p.title}`).join("\n") +
        "```\n",
    )
  }
}

module.exports = { PlaylistsManager }
